

extern char wallstyle[];
extern char wall_name[];
extern char floorstyle[];
extern char monsterstyle[];
extern char treasurestyle[];
extern char layoutstyle[];
extern char doorstyle[];
extern char decorstyle[];
extern char origin_map[];
extern char final_map[];
extern char exitstyle[];
extern char this_map[];

extern int Xsize;
extern int Ysize;
extern int layoutoptions1;
extern int layoutoptions2;
extern int layoutoptions3;
extern int symmetry;
extern int difficulty;
extern int dungeon_level;
extern int dungeon_depth;
extern int decoroptions;
extern int orientation;
extern int origin_y;
extern int origin_x;
extern int random_seed;
extern long unsigned int total_map_hp;
extern int map_layout_style;
extern int treasureoptions;
extern int symmetry_used;
extern int generate_treasure_now;

int load_parameters(FILE *fp, int bufstate);

mapstruct *generate_random_map(char *InFileName,char *outFileName);
char **layoutgen();
char **symmetrize_layout(char **maze,int sym);
void roomify_layout(char **maze);
void doorify_layout(char **maze);
void put_doors(mapstruct *,char **maze,char *doorstyle);
void put_decor(mapstruct *,char **maze,char *decorstyle,int decor_option);
void place_exits(mapstruct *,char **maze,char *exitstyle,int orientation);
void place_treasure(mapstruct *map,char **layout, char *treasure_style,int treasureoptions); 
char ** rotate_layout(char **layout,int rotation);
int surround_flag(char **layout,int x,int y);
int surround_flag2(char **layout,int x,int y);
int surround_flag3(mapstruct *map,int x,int y);
int surround_flag4(mapstruct *map,int x,int y);
int wall_blocked(mapstruct *m, int x, int y);
int can_make_wall(char **layout,int x,int y,int dir);
int make_wall(char **layout, int x, int y, int dir); 
object * retrofit_joined_wall(mapstruct *the_map,int i,int j,int insert_flag);
mapstruct *make_map_floor(char **layout, char *floorstyle);
void make_map_walls(mapstruct *m, char **layout, char *wallstyle);
void place_monsters(mapstruct *m,char *monsterstyle,int difficulty);
void insert_multisquiare_ob_in_map(object *op,mapstruct *map);
void write_map_parameters_to_string(char *buf);
void find_enclosed_spot(mapstruct *map,int *x,int *y);
object ** surround_by_doors(mapstruct *map,int x,int y,int opts);
object **find_doors_in_room(mapstruct *map,int x,int y);
void lock_and_hide_doors(object **doorlist,mapstruct *map,int opts);
void keyplace(mapstruct *map,int x,int y,char *keybuf,int door_flag,int n_keys);
object *find_monster_in_room(mapstruct *map,int x,int y);
int obj_count_in_map(mapstruct *map, int x, int y);

void find_spot_in_room(mapstruct *map,int x,int y,int *kx,int *ky);
object * place_chest(int treasureoptions,int i,int j,mapstruct *map, mapstruct *style_map,int n_treasures);
#define ONION_LAYOUT 1
#define MAZE_LAYOUT 2
#define NROFLAYOUTS 2

/* symmetry definitions--used in this file AND in treasure.c:
the numerical values matter so don't change them. */
#define RANDOM_SYM 0
#define NO_SYM 1
#define X_SYM 2
#define Y_SYM 3
#define XY_SYM 4


/*  a macro to get a strongly centered random distribution,
    from 0 to x, centered at x/2 */
#define BC_RANDOM(x) ((int) ((RANDOM() % (x)+RANDOM()%(x)+RANDOM()%(x))/3.))
